#pragma once

#include "v3.h"
#include "ppc.h"
#include "framebuffer.h"

class TMesh {
public:
  bool enabled;
  bool isReflective;
  bool msi;
  bool renderWF;
  V3 *verts, *cols, *tcs, *normals;
  int vertsN;
  unsigned int *tris;
  int trisN;
  FrameBuffer *tmap;
  TMesh() : enabled(true), msi(true), verts(0), vertsN(0), 
    tris(0), trisN(0), cols(0), tcs(0), tmap(0), projTM(0),
    projPPC(0), renderWF(false), normals(0), isReflective(false) {};
  void SetCube(V3 center, float sl);
  void SetRectangle(float wf, float hf, FrameBuffer *_tmap = 0);
  void Render(PPC *ppc, FrameBuffer *fb);
  void RenderWF(PPC *ppc, FrameBuffer *fb);
  void RenderPoints(PPC *ppc, FrameBuffer *fb, int pSize);
  void RotateAboutArbitraryAxis(V3 aO, V3 aDir, float theta);
  V3 GetCenter();
  void Load(char *fname);
  void Translate(V3 transv);
  void Scale(float scalef);
  void ScaleAboutCenter(float scalef);
  AABB GetAABB();
  void SetFromFB(FrameBuffer *fb, PPC *ppc);
  FrameBuffer *projTM;
  PPC *projPPC;
  void RenderHW();
};

